/* TODO - Nothing! Do not modify this file 
*/


#define _GNU_SOURCE
#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 

#include "tools.h"

/* remove when CLUE is accepting beyond ANSI */ 
extern char* strdup( const char*); 





/* Students will provide tests for all of the above functions
   See tests.c for details on the required functions and data structures
*/
extern const int NB_TESTS; 
extern const char * tests_inputs[];
extern const char * tests_expected[];

/* Forward definition of prototype, defined at the end of this source file */
void runAllTests(); 

/* MAIN starts here  */
int main()
{
    printf("\tWelcome to PA202\n\n");
    runAllTests();    
   
    return EXIT_SUCCESS;    
}


void runAllTests(){
    /* ROLE       Runs all the tests specified and displays results
    */
    int i; 
    char *test_input       		= NULL; 	/* what we provide our function with */
    const char *test_expected   = NULL;  	/* what we expect the result to be */
    char *test_observed    		= NULL; 	/* what our function returns */
    int test_outcome;              			/* test successful or not? */
     
    /* let's iterate over all available tests */
    for(i=0; i < NB_TESTS; i++){
            printf("Test #%d\t\t", i); 
             
            /* setting up this specific test */
            test_input = (char*)strdup(tests_inputs[i]); 
            test_expected = tests_expected[i];
              
            /* getting the result from our implementations */
            words_modify(test_input); 
              
            /* test_input has been modified */
            test_observed = test_input; 
              
            if (!test_observed){
                printf("FAILED\n"); 
                continue;
            }
              
            test_outcome = strcmp(test_observed, test_expected);
              
            /* verifying if observed result is the expected one */
            if ( test_outcome != 0){ 
                   /* if expected output is not the produced one, test fails*/
                   printf("FAILED");
            }else{
                    /* otherwise test was successfull */
                    printf("OK");
            }
            printf("\t\t[%s]->[%s]", tests_inputs[i], test_observed); 
            printf("\n"); 
     
            /* de-allocating memory allocated by words_modify */
            if (test_observed) free(test_observed); 
			test_input = NULL; 	/* test input is now a dangling pointer */
    }
}

